' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' C_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2011/01/25 
'
' FVC05 4ch only Sample Program
' -----------------------------------------------------------------
Public Class Form_FVC05_4CHSAMPLE

    Private m_image1_CH0 As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()         'Video1CH0p摜i[̈
    Private m_image1_CH1 As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()         'Video1CH1p摜i[̈
    Private m_image2_CH0 As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()         'Video2CH0p摜i[̈
    Private m_image2_CH1 As FVIL.Data.CFviImage = New FVIL.Data.CFviImage()         'Video2CH1p摜i[̈
    Private m_video1 As FVIL.Video.CFviVideoFVC05 = New FVIL.Video.CFviVideoFVC05   'FVC05NX
    Private m_video2 As FVIL.Video.CFviVideoFVC05 = New FVIL.Video.CFviVideoFVC05   'FVC05NX
    Private m_timer As FVIL.CFviTimeCounter = New FVIL.CFviTimeCounter()            'ԌvNX

    Dim intErr1 As Integer                                                          'G[ԍi[ϐ
    Dim intErr2 As Integer                                                          'G[ԍi[ϐ
    Public m_strIniFilePath As String                                               'init@CitpXj

    Private m_flgVideo1Opened As Boolean                                            'rfIfoCX̃I[v
    Private m_flgVideo2Opened As Boolean                                            'rfIfoCX̃I[v
    Private m_flgFreerun As Boolean                                                 't[̏

    Private Sub FormMainLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'FVIL̏
        'AvP[VNA ̊֐ĂяoăCuĂB 
        '̎ACZX̔F؂s܂BpԒłĂȀ͕KsKvL܂B 
        'sȂꍇ́AveNgꂽNX̎sł܂B
        FVIL._SetUp.InitVisionLibrary()

        'ԕϐ̏
        m_flgVideo1Opened = False
        m_flgVideo2Opened = False
        m_flgFreerun = False

        'vԃeLXg{bNX
        TextBoxTime.Text = "0"

        'gK[hR{{bNX
        ComboBoxVideo1Trigger.Items.Clear()
        ComboBoxVideo1Trigger.Items.Add("m[}")
        ComboBoxVideo1Trigger.Items.Add("gK")
        ComboBoxVideo1Trigger.Items.Add("OgK")
        ComboBoxVideo1Trigger.SelectedIndex = 0
        ComboBoxVideo2Trigger.Items.Clear()
        ComboBoxVideo2Trigger.Items.Add("m[}")
        ComboBoxVideo2Trigger.Items.Add("gK")
        ComboBoxVideo2Trigger.Items.Add("OgK")
        ComboBoxVideo2Trigger.SelectedIndex = 0

        'QlR{{bNX
        ComboBoxBinarize.Items.Clear()
        ComboBoxBinarize.Items.Add("OC")
        ComboBoxBinarize.Items.Add("l")
        ComboBoxBinarize.SelectedIndex = 0

    End Sub

    ''' <summary>
    ''' tH[\Jn Cxgnh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gpmF܂B
    ''' </remarks>
    Private Sub formMain_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        'gp̊mF
        Dim licence_dialog As New dialogLicence
        If (licence_dialog.ShowDialog(Me) <> Windows.Forms.DialogResult.OK) Then
            Me.Close() 'gpȂꍇ̓TvvO̓I
            Exit Sub
        End If

        'init@CI
        fnSetIniFile()

        '`imagẽZbg
        CFviImageViewVideo1CH0.Image = Me.m_image1_CH0
        CFviImageViewVideo1CH1.Image = Me.m_image1_CH1
        CFviImageViewVideo2CH0.Image = Me.m_image2_CH0
        CFviImageViewVideo2CH1.Image = Me.m_image2_CH1

    End Sub

    ''' <summary>
    ''' I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' AvP[VIB
    ''' </remarks>
    Private Sub FormMainFormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        'rfIfoCXI[vĂꍇ̓N[Y
        If (m_flgVideo1Opened = True) Then
            m_video1.Close()
            m_flgVideo1Opened = False
        End If
        If (m_flgVideo2Opened = True) Then
            m_video2.Close()
            m_flgVideo2Opened = False
        End If

    End Sub

    ''' <summary>
    ''' init@CI֐
    ''' </summary>
    ''' <remarks>
    ''' init@C̑I܂B
    ''' </remarks>
    Private Sub fnSetIniFile()
        Dim formbroseini As New Form_BROWSEINI  'init@Cݒ

        'init@C̑I
        m_strIniFilePath = ""
        If (Form_BROWSEINI.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            m_strIniFilePath = Form_BROWSEINI.strIniFilePath
        End If

        If (m_strIniFilePath.Length > 0) Then
            Try
                'rfIfoCXI[vĂꍇ̓N[Y
                If (m_video1.IsOpen = True) Then
                    m_video1.Close()
                    m_flgVideo1Opened = False
                End If
                If (m_video2.IsOpen = True) Then
                    m_video2.Close()
                    m_flgVideo2Opened = False
                End If

                'foCXI[v
                m_video1.Open(-1, 0)
                m_video2.Open(-1, 0)
                m_flgVideo1Opened = True
                m_flgVideo2Opened = True

                'VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)

                'QJ荞݂ɐݒ
                m_video1.SimGrab = 2
                m_video2.SimGrab = 2

                'init@CR|[lgɐݒ
                If (m_strIniFilePath.Length > 0) Then
                    m_video1.LoadIniFile(m_strIniFilePath)
                    m_video2.LoadIniFile(m_strIniFilePath)
                End If

                '捞摜𐳋K
                m_video1.ChangeImageSize(m_image1_CH0)
                m_video1.ChangeImageSize(m_image1_CH1)
                m_video2.ChangeImageSize(m_image2_CH0)
                m_video2.ChangeImageSize(m_image2_CH1)

                'Xe[^X\̍XV
                'gK[h̎擾
                ComboBoxVideo1Trigger.SelectedIndex = m_video1.Trigger
                ComboBoxVideo2Trigger.SelectedIndex = m_video2.Trigger
                'JIԂ̎擾
                NumericUpDownVideo1Exposure.Value = m_video1.ExposureTime
                NumericUpDownVideo2Exposure.Value = m_video2.ExposureTime

                'e`l̃Xe[^X擾
                'rfI̓ItZbg̎擾
                NumericUpDownVideo1CH0Offset.Value = m_video1.VideoOffsetCH0
                NumericUpDownVideo1CH1Offset.Value = m_video1.VideoOffsetCH1
                NumericUpDownVideo2CH0Offset.Value = m_video2.VideoOffsetCH0
                NumericUpDownVideo2CH1Offset.Value = m_video2.VideoOffsetCH1
                'Ql臒l̎擾
                NumericUpDownVideo1CH0Threshold.Value = m_video1.BinarizeCH0.Threshold
                NumericUpDownVideo1CH1Threshold.Value = m_video1.BinarizeCH1.Threshold
                NumericUpDownVideo2CH0Threshold.Value = m_video2.BinarizeCH0.Threshold
                NumericUpDownVideo2CH1Threshold.Value = m_video2.BinarizeCH1.Threshold

                'Qlݒ(CH0)̎擾
                ComboBoxBinarize.SelectedIndex = m_video1.BinarizeCH0.Mode

                '荞݂̐ݒ
                m_video1.SimGrab() = 2              'QJ荞
                m_video2.SimGrab() = 2              'QJ荞
                'gKL[h̐ݒ
                m_video1.TrgSharingMode() = 0       'Ɨ[h
                m_video2.TrgSharingMode() = 0       'Ɨ[h
            Catch ex As Exception
                'G[
                intErr1 = m_video1.ErrorCode
                intErr2 = m_video2.ErrorCode
                MessageBox.Show("ErrorCode:Video1= " + intErr1.ToString + ",Video2= " + intErr2.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try

        Else
            'init@CȈꍇ̓TvvO̓I
            Me.Close()
            Exit Sub
        End If

    End Sub

    ''' <summary>
    ''' Grab One{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J荞݁B
    ''' </remarks>
    Private Sub ButtonGrabOne_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabOne.Click
        Dim msec As Double
        Dim Status1 As Integer = 1
        Dim Status2 As Integer = 1

        Try
            If ((m_flgVideo1Opened = True) And (m_flgVideo2Opened = True)) Then
                'ԑJn
                m_timer.Start()
                If (CheckBoxSimulCapture.Checked) Then
                    'J荞
                    m_video2.GrabImageASync(Me.m_image2_CH0, Me.m_image2_CH1)
                    m_video1.GrabImageSync(Me.m_image1_CH0, Me.m_image1_CH1)
                Else
                    'J荞
                    m_video1.GrabImageASync(Me.m_image1_CH0, Me.m_image1_CH1)
                    m_video2.GrabImageASync(Me.m_image2_CH0, Me.m_image2_CH1)
                End If
                Do Until ((Status1 = 0) And (Status2 = 0))
                    Status1 = m_video1.GrabStatus()
                    Status2 = m_video2.GrabStatus()
                Loop
                'ԑI
                msec = m_timer.Stop()
                '莞ԕ\
                TextBoxTime.Text = msec.ToString("0.000")
                'ĕ`
                CFviImageViewVideo1CH0.Refresh()
                CFviImageViewVideo1CH1.Refresh()
                CFviImageViewVideo2CH0.Refresh()
                CFviImageViewVideo2CH1.Refresh()
            End If
        Catch ex As Exception
            'G[
            intErr1 = m_video1.ErrorCode
            intErr2 = m_video2.ErrorCode
            MessageBox.Show("ErrorCode:Video1= " + intErr1.ToString + ",Video2= " + intErr2.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Grab Continue{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' t[JnE~B
    ''' </remarks>
    Private Sub ButtonGrabContinue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabContinue.Click
        '{^\ύX
        If (m_flgFreerun = True) Then
            ButtonGrabContinue.Text = "Grab Continue"
            ButtonGrabOne.Enabled = True
            m_flgFreerun = False
            Timer1.Enabled = False
        Else
            ButtonGrabContinue.Text = "Stop"
            ButtonGrabOne.Enabled = False
            m_flgFreerun = True
            Timer1.Interval = 50
            Timer1.Start()
        End If
        Application.DoEvents()

    End Sub

    ''' <summary>
    ''' t[
    ''' </summary>
    ''' <remarks>
    ''' AJ荞݁B
    ''' </remarks>
    Private Sub Timer1Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim msec As Double
        Dim Status1 As Integer = 1
        Dim Status2 As Integer = 1

        Timer1.Stop()

        Try
            If ((m_flgVideo1Opened = True) And (m_flgVideo2Opened = True)) Then
                'ԑJn
                m_timer.Start()
                If (CheckBoxSimulCapture.Checked) Then
                    'J荞
                    m_video2.GrabImageASync(Me.m_image2_CH0, Me.m_image2_CH1)
                    m_video1.GrabImageSync(Me.m_image1_CH0, Me.m_image1_CH1)
                Else
                    'J荞
                    m_video1.GrabImageASync(Me.m_image1_CH0, Me.m_image1_CH1)
                    m_video2.GrabImageASync(Me.m_image2_CH0, Me.m_image2_CH1)
                End If
                Do Until ((Status1 = 0) And (Status2 = 0))
                    Status1 = m_video1.GrabStatus()
                    Status2 = m_video2.GrabStatus()
                Loop
                'ԑI
                msec = m_timer.Stop()
                '莞ԕ\
                TextBoxTime.Text = msec.ToString("0.000")
                'ĕ`
                CFviImageViewVideo1CH0.Refresh()
                CFviImageViewVideo1CH1.Refresh()
                CFviImageViewVideo2CH0.Refresh()
                CFviImageViewVideo2CH1.Refresh()
            End If
            Timer1.Enabled = True

        Catch ex As Exception
            ButtonGrabContinue.Text = "Grab Continue"
            ButtonGrabOne.Enabled = True
            m_flgFreerun = False
            Timer1.Enabled = False

            'G[
            intErr1 = m_video1.ErrorCode
            intErr2 = m_video2.ErrorCode
            MessageBox.Show("ErrorCode:Video1= " + intErr1.ToString + ",Video2= " + intErr2.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Video1 Trigger ModeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' m[}[hEgK[hEOgK[h̑IB
    ''' </remarks>
    Private Sub ComboBoxTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxVideo1Trigger.SelectedIndexChanged, ComboBoxVideo1Trigger.SelectedIndexChanged
        Try
            If (m_flgVideo1Opened = True) Then
                If (CheckBoxSimulCapture.Checked) Then
                    m_video1.Trigger = ComboBoxVideo1Trigger.SelectedIndex + 1
                Else
                    m_video1.Trigger = ComboBoxVideo1Trigger.SelectedIndex
                End If
                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)
            End If
        Catch ex As Exception
            'G[
            intErr1 = m_video1.ErrorCode
            MessageBox.Show("ErrorCode:Video1= " + intErr1.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Video2 Trigger ModeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' m[}[hEgK[hEOgK[h̑IB
    ''' </remarks>
    Private Sub ComboBoxVideo2Trigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxVideo2Trigger.SelectedIndexChanged
        Try
            If (m_flgVideo2Opened = True) Then
                If (CheckBoxSimulCapture.Checked) Then
                    m_video2.Trigger = 2
                Else
                    m_video2.Trigger = ComboBoxVideo2Trigger.SelectedIndex
                End If
                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)
            End If
        Catch ex As Exception
            'G[
            intErr2 = m_video2.ErrorCode
            MessageBox.Show("ErrorCode:Video2= " + intErr2.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Simultaneous Capture`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 荞ݐݒԂ̐ݒB
    ''' </remarks>
    Private Sub CheckBoxSimulCapture_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxSimulCapture.CheckedChanged
        Try
            If (m_flgVideo1Opened = True) Then
                If (CheckBoxSimulCapture.Checked) Then
                    'gK[hR{{bNX
                    ComboBoxVideo1Trigger.Items.Clear()
                    ComboBoxVideo1Trigger.Items.Add("gK")
                    ComboBoxVideo1Trigger.Items.Add("OgK")
                    ComboBoxVideo1Trigger.SelectedIndex = 0

                    'gKL[h̐ݒ
                    m_video1.TrgSharingMode() = 2       '}X^[[h
                    'gK[h̐ݒ
                    m_video1.Trigger() = 1
                Else
                    'gK[hR{{bNX
                    ComboBoxVideo1Trigger.Items.Clear()
                    ComboBoxVideo1Trigger.Items.Add("m[}")
                    ComboBoxVideo1Trigger.Items.Add("gK")
                    ComboBoxVideo1Trigger.Items.Add("OgK")
                    ComboBoxVideo1Trigger.SelectedIndex = 0

                    'gKL[h̐ݒ
                    m_video1.TrgSharingMode() = 0       'Ɨ[h
                    'gK[h̐ݒ
                    m_video1.Trigger() = 0
                End If
            End If
            If (m_flgVideo2Opened = True) Then
                If (CheckBoxSimulCapture.Checked) Then
                    'gK[hR{{bNX
                    ComboBoxVideo2Trigger.Items.Clear()
                    ComboBoxVideo2Trigger.Items.Add("OgK")
                    ComboBoxVideo2Trigger.SelectedIndex = 0

                    'gKL[h̐ݒ
                    m_video2.TrgSharingMode() = 1       'X[u[h
                    'gK[h̐ݒ
                    m_video2.Trigger() = 2
                Else
                    'gK[hR{{bNX
                    ComboBoxVideo2Trigger.Items.Clear()
                    ComboBoxVideo2Trigger.Items.Add("m[}")
                    ComboBoxVideo2Trigger.Items.Add("gK")
                    ComboBoxVideo2Trigger.Items.Add("OgK")
                    ComboBoxVideo2Trigger.SelectedIndex = 0

                    'gKL[h̐ݒ
                    m_video2.TrgSharingMode() = 0       'Ɨ[h
                    'gK[h̐ݒ
                    m_video2.Trigger() = 0
                End If
            End If
            'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
            '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
            'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
            Threading.Thread.Sleep(350)
        Catch ex As Exception
            'G[
            intErr1 = m_video1.ErrorCode
            intErr2 = m_video2.ErrorCode
            MessageBox.Show("ErrorCode:Video1= " + intErr1.ToString + ",Video2= " + intErr2.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Video1 Exposure NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JIԂ̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownVideo1Exposure_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownVideo1Exposure.ValueChanged
        Try
            If (m_flgVideo1Opened = True) Then
                m_video1.ExposureTime = NumericUpDownVideo1Exposure.Value
            End If
        Catch ex As Exception
            'G[
            intErr1 = m_video1.ErrorCode
            MessageBox.Show("ErrorCode:Video1= " + intErr1.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Video2 Exposure NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JIԂ̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownVideo2Exposure_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownVideo2Exposure.ValueChanged
        Try
            If (m_flgVideo2Opened = True) Then
                m_video2.ExposureTime = NumericUpDownVideo2Exposure.Value
            End If
        Catch ex As Exception
            'G[
            intErr2 = m_video2.ErrorCode
            MessageBox.Show("ErrorCode:Video2= " + intErr2.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Video1 Offset CH0 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ItZbg(CH0)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownVideo1CH0Offset_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownVideo1CH0Offset.ValueChanged
        Try
            If (m_flgVideo1Opened = True) Then
                '`lOɐݒ
                m_video1.VideoOffsetCH0 = NumericUpDownVideo1CH0Offset.Value
            End If
        Catch ex As Exception
            'G[
            intErr1 = m_video1.ErrorCode
            MessageBox.Show("ErrorCode:Video1= " + intErr1.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Video1 Offset CH1 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ItZbg(CH1)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownVideo1CH1Offset_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownVideo1CH1Offset.ValueChanged
        Try
            If (m_flgVideo1Opened = True) Then
                '`lPɐݒ
                m_video1.VideoOffsetCH1 = NumericUpDownVideo1CH1Offset.Value
            End If
        Catch ex As Exception
            'G[
            intErr1 = m_video1.ErrorCode
            MessageBox.Show("ErrorCode:Video1= " + intErr1.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Video2 Offset CH0 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ItZbg(CH0)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownVideo2CH0Offset_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownVideo2CH0Offset.ValueChanged
        Try
            If (m_flgVideo2Opened = True) Then
                '`lOɐݒ
                m_video2.VideoOffsetCH0 = NumericUpDownVideo2CH0Offset.Value
            End If
        Catch ex As Exception
            'G[
            intErr2 = m_video2.ErrorCode
            MessageBox.Show("ErrorCode:Video2= " + intErr2.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Video2 Offset CH1 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ItZbg(CH1)̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownVideo2CH1Offset_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownVideo2CH1Offset.ValueChanged
        Try
            If (m_flgVideo2Opened = True) Then
                '`lPɐݒ
                m_video2.VideoOffsetCH1 = NumericUpDownVideo2CH1Offset.Value
            End If
        Catch ex As Exception
            'G[
            intErr2 = m_video2.ErrorCode
            MessageBox.Show("ErrorCode:Video2= " + intErr2.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Binarize ComboBox
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Ql@\̐ݒ
    ''' </remarks>
    Private Sub ComboBoxBinarize_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxBinarize.SelectedIndexChanged
        Try
            Dim bin As FVIL.Video.CFviVideoBinarize
            If (m_flgVideo1Opened = True) Then
                bin = m_video1.Binarize
                bin.Mode = ComboBoxBinarize.SelectedIndex
                'Ql@\̐ݒ
                m_video1.BinarizeCH0 = bin
                m_video1.BinarizeCH1 = bin
                '捞摜𐳋K
                m_video1.ChangeImageSize(m_image1_CH0)
                m_video1.ChangeImageSize(m_image1_CH1)
            End If
            If (m_flgVideo2Opened = True) Then
                bin = m_video2.Binarize
                bin.Mode = ComboBoxBinarize.SelectedIndex
                'Ql@\̐ݒ
                m_video2.BinarizeCH0 = bin
                m_video2.BinarizeCH1 = bin
                '捞摜𐳋K
                m_video2.ChangeImageSize(m_image2_CH0)
                m_video2.ChangeImageSize(m_image2_CH1)
            End If
        Catch ex As Exception
            'G[
            intErr1 = m_video1.ErrorCode
            intErr2 = m_video2.ErrorCode
            MessageBox.Show("ErrorCode:Video1= " + intErr1.ToString + ",Video2= " + intErr2.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Video1 Threshold CH0 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2ll(CH0)̐ݒ
    ''' </remarks>
    Private Sub NumericUpDownVideo1CH0Threshold_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownVideo1CH0Threshold.ValueChanged
        Try
            If (m_flgVideo1Opened = True) Then
                Dim bin As FVIL.Video.CFviVideoBinarize = m_video1.Binarize
                bin.Threshold = NumericUpDownVideo1CH0Threshold.Value
                '`lOɐݒ
                m_video1.BinarizeCH0 = bin
            End If
        Catch ex As Exception
            'G[
            intErr1 = m_video1.ErrorCode
            MessageBox.Show("ErrorCode:Video1= " + intErr1.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Video1 Threshold CH1 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2ll(CH1)̐ݒ
    ''' </remarks>
    Private Sub NumericUpDownVideo1CH1Threshold_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownVideo1CH1Threshold.ValueChanged
        Try
            If (m_flgVideo1Opened = True) Then
                Dim bin As FVIL.Video.CFviVideoBinarize = m_video1.Binarize
                bin.Threshold = NumericUpDownVideo1CH1Threshold.Value
                '`lPɐݒ
                m_video1.BinarizeCH1 = bin
            End If
        Catch ex As Exception
            'G[
            intErr1 = m_video1.ErrorCode
            MessageBox.Show("ErrorCode:Video1= " + intErr1.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Video2 Threshold CH0 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2ll(CH0)̐ݒ
    ''' </remarks>
    Private Sub NumericUpDownVideo2CH0Threshold_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownVideo2CH0Threshold.ValueChanged
        Try
            If (m_flgVideo2Opened = True) Then
                Dim bin As FVIL.Video.CFviVideoBinarize = m_video2.Binarize
                bin.Threshold = NumericUpDownVideo2CH0Threshold.Value
                '`lOɐݒ
                m_video2.BinarizeCH0 = bin
            End If
        Catch ex As Exception
            'G[
            intErr2 = m_video2.ErrorCode
            MessageBox.Show("ErrorCode:Video2= " + intErr2.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Video2 Threshold CH1 NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2ll(CH1)̐ݒ
    ''' </remarks>
    Private Sub NumericUpDownVideo2CH1Threshold_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownVideo2CH1Threshold.ValueChanged
        Try
            If (m_flgVideo2Opened = True) Then
                Dim bin As FVIL.Video.CFviVideoBinarize = m_video2.Binarize
                bin.Threshold = NumericUpDownVideo2CH1Threshold.Value
                '`lPɐݒ
                m_video2.BinarizeCH1 = bin
            End If
        Catch ex As Exception
            'G[
            intErr2 = m_video2.ErrorCode
            MessageBox.Show("ErrorCode:Video2= " + intErr2.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' ReLoad Ini File{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' rfIݒpinit@C̍ĐݒB
    ''' </remarks>
    Private Sub ButtonReLoadIni_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReLoadIni.Click
        't[Ȃ΁A~B
        If (m_flgFreerun = True) Then
            ButtonGrabContinue.Text = "Grab Continue"
            ButtonGrabOne.Enabled = True
            m_flgFreerun = False
            Timer1.Enabled = False
            Application.DoEvents()
        End If

        'init@CI
        fnSetIniFile()

    End Sub

    ''' <summary>
    ''' Save Image{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜ۑ
    ''' </remarks>
    Private Sub ButtonSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveImage.Click
        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"
        ofdlg.OverwritePrompt = True

        Try
            If (ofdlg.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
                Dim name As String
                Dim temp As Integer
                'gq܂ł̕Zo
                temp = ofdlg.FileName.Length - ofdlg.FileName.LastIndexOfAny(".")
                temp = ofdlg.FileName.Length - temp

                '̊֐́AȈՓIɉ摜t@C̕ۑŝׂ̂łB 
                '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 

                'rfIP`lỎ摜ۑ
                name = ofdlg.FileName.Insert(temp, "_Video1CH0")
                FVIL.File.Function.SaveImageFile(name, CFviImageViewVideo1CH0.Image)
                'rfIP`lP̉摜ۑ
                name = ofdlg.FileName.Insert(temp, "_Video1CH1")
                FVIL.File.Function.SaveImageFile(name, CFviImageViewVideo1CH1.Image)
                'rfIQ`lỎ摜ۑ
                name = ofdlg.FileName.Insert(temp, "_Video2CH0")
                FVIL.File.Function.SaveImageFile(name, CFviImageViewVideo2CH0.Image)
                'rfIQ`lP̉摜ۑ
                name = ofdlg.FileName.Insert(temp, "_Video2CH1")
                FVIL.File.Function.SaveImageFile(name, CFviImageViewVideo2CH1.Image)

                'ۑt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                '1) bmpt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                'file.Save(ofdlg.FileName, m_image)

                '2) jpgt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                'file.Save(ofdlg.FileName, m_image)
            End If
        Catch ex As FVIL.CFviException
            Dim msg As System.String = System.String.Format("CuO𔭍s܂Bcode={0} func={1}", ex.ErrorCode, ex.Function)
            Select Case (ex.ErrorCode)
                Case FVIL.ErrorCode.NOT_SUPPORTED, _
                 FVIL.ErrorCode.INVALID_OBJECT
                    msg += vbCrLf + "T|[gĂȂ摜IuWFNgłB"
                    msg += vbCrLf + "Raw `ŕۑĂB"
            End Select
            MessageBox.Show(msg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' x1{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' {ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMag1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMag1.Click
        '摜̕\{̎擾܂͐ݒs܂B1.0Ǝw肷Ɠ{ŕ\܂B
        '{ĺA0.5Ƃꍇ́AE1/2ƂȂAʐς1/4ɂȂ܂B
        '3.0Ƃꍇ́AE3{ƂȂAʐς9{ɂȂ܂B
        '\{̐ݒ
        CFviImageViewVideo1CH0.Display.Magnification = 1.0
        CFviImageViewVideo1CH1.Display.Magnification = 1.0
        CFviImageViewVideo2CH0.Display.Magnification = 1.0
        CFviImageViewVideo2CH1.Display.Magnification = 1.0
        'ĕ`
        CFviImageViewVideo1CH0.Refresh()
        CFviImageViewVideo1CH1.Refresh()
        CFviImageViewVideo2CH0.Refresh()
        CFviImageViewVideo2CH1.Refresh()

    End Sub

    ''' <summary>
    ''' Fit{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
    ''' </remarks>
    Private Sub ButtonFit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFit.Click
        '摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
        '\{𒲐
        CFviImageViewVideo1CH0.FitImageSize()
        CFviImageViewVideo1CH1.FitImageSize()
        CFviImageViewVideo2CH0.FitImageSize()
        CFviImageViewVideo2CH1.FitImageSize()
        'ĕ`
        CFviImageViewVideo1CH0.Refresh()
        CFviImageViewVideo1CH1.Refresh()
        CFviImageViewVideo2CH0.Refresh()
        CFviImageViewVideo2CH1.Refresh()

    End Sub

    ''' <summary>
    ''' {{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂B
    ''' </remarks>
    Private Sub ButtonPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonPlus.Click
        Dim Value As Double
        '{̎擾
        Value = CFviImageViewVideo1CH0.Display.Magnification
        '\{̐ݒ
        Value = Value + 0.5
        CFviImageViewVideo1CH0.Display.Magnification = Value
        CFviImageViewVideo1CH1.Display.Magnification = Value
        CFviImageViewVideo2CH0.Display.Magnification = Value
        CFviImageViewVideo2CH1.Display.Magnification = Value
        'ĕ`
        CFviImageViewVideo1CH0.Refresh()
        CFviImageViewVideo1CH1.Refresh()
        CFviImageViewVideo2CH0.Refresh()
        CFviImageViewVideo2CH1.Refresh()

    End Sub

    ''' <summary>
    ''' |{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂BA{OȉɂȂꍇ͔{0.1ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMinus.Click
        Dim Value As Double
        '{̎擾
        Value = CFviImageViewVideo1CH0.Display.Magnification
        '\{̐ݒ
        Value = Value - 0.5
        If (Value <= 0) Then
            Value = 0.1       'Oȉݒ肷ƃG[ɂȂ̂0.1ݒ肷
        End If
        CFviImageViewVideo1CH0.Display.Magnification = Value
        CFviImageViewVideo1CH1.Display.Magnification = Value
        CFviImageViewVideo2CH0.Display.Magnification = Value
        CFviImageViewVideo2CH1.Display.Magnification = Value
        'ĕ`
        CFviImageViewVideo1CH0.Refresh()
        CFviImageViewVideo1CH1.Refresh()
        CFviImageViewVideo2CH0.Refresh()
        CFviImageViewVideo2CH1.Refresh()

    End Sub

    ''' <summary>
    ''' Ascope`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ASCOPE̕\ؑւ܂B
    ''' </remarks>
    Private Sub CheckBoxAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxAscope.CheckedChanged
        'ASCOPEI[oC̐ݒ
        If (CheckBoxAscope.CheckState) Then
            'ASCOPE̕\LɂB
            CFviImageViewVideo1CH0.Display.OverlayAscope.Enable = True
            CFviImageViewVideo1CH0.Display.OverlayAscope.Active = True
            CFviImageViewVideo1CH1.Display.OverlayAscope.Enable = True
            CFviImageViewVideo1CH1.Display.OverlayAscope.Active = True
            CFviImageViewVideo2CH0.Display.OverlayAscope.Enable = True
            CFviImageViewVideo2CH0.Display.OverlayAscope.Active = True
            CFviImageViewVideo2CH1.Display.OverlayAscope.Enable = True
            CFviImageViewVideo2CH1.Display.OverlayAscope.Active = True
        Else
            'ASCOPE̕\𖳌ɂB
            CFviImageViewVideo1CH0.Display.OverlayAscope.Enable = False
            CFviImageViewVideo1CH0.Display.OverlayAscope.Active = False
            CFviImageViewVideo1CH1.Display.OverlayAscope.Enable = False
            CFviImageViewVideo1CH1.Display.OverlayAscope.Active = False
            CFviImageViewVideo2CH0.Display.OverlayAscope.Enable = False
            CFviImageViewVideo2CH0.Display.OverlayAscope.Active = False
            CFviImageViewVideo2CH1.Display.OverlayAscope.Enable = False
            CFviImageViewVideo2CH1.Display.OverlayAscope.Active = False
        End If
        'ĕ`
        CFviImageViewVideo1CH0.Refresh()
        CFviImageViewVideo1CH1.Refresh()
        CFviImageViewVideo2CH0.Refresh()
        CFviImageViewVideo2CH1.Refresh()

    End Sub

End Class
